#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>
#include <string.h>


int hossz(char zar[])
	{
	int h;
	for(h = 0; zar[h] != '\n' && zar[h] != '\0'; ++h);
	return h;
	}

/*6. feladat: nyit()*/
bool nyit(char jo[], char proba[])
	{
	bool egyezik = (hossz(jo) == hossz(proba));
	int elteres = 0;
	if ( egyezik) {
			elteres = jo[0] - proba[0];
			int i;
			for ( i = 1; i < hossz(jo); ++i) {
					if ((elteres - (jo[i] - proba[i])) % 10 != 0)
						egyezik = false;
					}
			}
	return egyezik;
	}



int main()
	{
	char kod[500][10 + 1];

	/*1. feladat: input*/
	FILE* fin;
	fin = fopen("ajto.txt", "rt");
	int n = 0, i, j;
	char temp[10 + 1];

	while(fscanf(fin, " %s", temp) != EOF) {
			strcpy(kod[n], temp);
			n++;
			}
	fclose(fin);

	char minta[10 + 1];

	printf("\n2. feladat\n");
	printf("Adja meg mi nyitja a zarat: ");
	scanf(" %s", minta);
	int mintahossz = hossz(minta);


	printf("\n3. feladat\n");
	for(i = 0; i < n; i++) {
			if(hossz(kod[i]) == mintahossz) {
					for(j = 0; kod[i][j] == minta[j]; ++j);
					if (j > mintahossz)
						printf(" %d", i + 1);
					}
			}
	printf("\n");

	printf("\n4. feladat\n");
	i = 0;
	j = 0;
	int stop = 0;
	/*bool stop = false;*/
	int db[10 + 1] = {0};
	while(i < n && !stop) {
			if (kod[i][j] == '\0') {
					i++;
					for (j = 0; j < 10; ++j) db[j] = 0;
					j = 0;
					}
			else {
					stop = db[kod[i][j] - '0'];
					/*stop = db[kod[i][j] - '0']==1 */
					/*Ha az adott rtk mr volt, akkor stop, klnben nvels.
					Megsprolhat az alternci, mert stop utn mr mindegy*/
					db[kod[i][j] - '0']++;
					j++;
					}
			}
	if ( i == n)
		printf("Nem volt ismetlodo szamjegy.\n");
	else
		printf("Az elso ismetlodest tartalmazo probalkozas sorszama: %d\n", i + 1);

	printf("\n5. feladat\n");
	srand(time(NULL));
	char generalt[11];
	for (j = 0; j < 10; ++j) generalt[j] = j + '0';
	for (j = 0; j < mintahossz; ++j ) {
			int next = rand() % (10 - j); /*A mg rendelkezsre ll szmok szma 10-j, helye: [j, 10 [*/
			char tmp = generalt[j];   /*Cserlem a j. helyre a rszsorozatbl kivlasztottat*/
			generalt[j] = generalt[j + next];
			generalt[j + next] = tmp;
			}
	generalt[mintahossz] = '\0';
	printf("Egy %d hosszu kodszam: %s\n", mintahossz, generalt);

	/*7. feladat*/
	FILE* fout;
	fout = fopen("siker.txt", "wt");
	for (i = 0; i < n; ++i) {
			if(hossz(kod[i]) != mintahossz)
				fprintf(fout, "%s hibas hossz\n", kod[i]);
			else {
					if(nyit(minta, kod[i]))
						fprintf(fout, "%s sikeres\n", kod[i]);
					else
						fprintf(fout, "%s hibas kodszam\n", kod[i]);
					}
			}
	fclose(fout);

	return 0;
	}
